# Managed API for GitLab
Managed API for GitLab is an API Client for GitLab by [Adaptavist](https://www.adaptavist.com/) primarily designed for the use in [ScriptRunner Connect](https://scriptrunnerconnect.com). You can read more about Managed APIs [here](https://docs.adaptavist.com/src/managed-apis).

This is a runtime agnostic version of the Managed API (with `core` suffix) that makes it easy to port it to any runtime you may want to use this Managed API on.

# Platform specific ports
- [ScriptRunner Connect](https://www.npmjs.com/package/@managed-api/gitlab-sr-connect)

# Supported API calls
- [fetch](https://docs.adaptavist.com/src/managed-apis/managed-api-abstractions)
- Branch
    - [createBranch](https://docs.gitlab.com/ee/api/branches.html#create-repository-branch)
    - [deleteBranch](https://docs.gitlab.com/ee/api/branches.html#delete-repository-branch)
    - [deleteMergedBranches](https://docs.gitlab.com/ee/api/branches.html#delete-merged-branches)
    - [getBranch](https://docs.gitlab.com/ee/api/branches.html#get-single-repository-branch)
    - [getBranches](https://docs.gitlab.com/ee/api/branches.html#list-repository-branches)
- Commit
    - [cherryPickCommit](https://docs.gitlab.com/ee/api/commits.html#cherry-pick-a-commit)
    - [createComment](https://docs.gitlab.com/ee/api/commits.html#post-comment-to-commit)
    - [createCommit](https://docs.gitlab.com/ee/api/commits.html#create-a-commit-with-multiple-files-and-actions)
    - [getComments](https://docs.gitlab.com/ee/api/commits.html#get-the-comments-of-a-commit)
    - [getCommit](https://docs.gitlab.com/ee/api/commits.html#get-a-single-commit)
    - [getCommitDiff](https://docs.gitlab.com/ee/api/commits.html#get-the-diff-of-a-commit)
    - [getCommitReferences](https://docs.gitlab.com/ee/api/commits.html#get-references-a-commit-is-pushed-to)
    - [getCommits](https://docs.gitlab.com/ee/api/commits.html#list-repository-commits)
    - [getDiscussions](https://docs.gitlab.com/ee/api/commits.html#get-the-discussions-of-a-commit)
    - [getGPGSignature](https://docs.gitlab.com/ee/user/project/repository/gpg_signed_commits/index.html)
    - [getMergeRequests](https://docs.gitlab.com/ee/api/commits.html#list-merge-requests-associated-with-a-commit)
    - [revertCommit](https://docs.gitlab.com/ee/api/commits.html#revert-a-commit)
    - Status
        - [createBuildStatus](https://docs.gitlab.com/ee/api/commits.html#post-the-build-status-to-a-commit)
        - [getStatuses](https://docs.gitlab.com/ee/api/commits.html#list-the-statuses-of-a-commit)
- Epic
    - [createEpic](https://docs.gitlab.com/ee/api/epics.html#new-epic)
    - [createTodoItem](https://docs.gitlab.com/ee/api/epics.html#create-a-to-do-item)
    - [deleteEpic](https://docs.gitlab.com/ee/api/epics.html#delete-epic)
    - [getEpic](https://docs.gitlab.com/ee/api/epics.html#single-epic)
    - [getEpicsForGroup](https://docs.gitlab.com/ee/api/epics.html#list-epics-for-a-group)
    - [updateEpic](https://docs.gitlab.com/ee/api/epics.html#update-epic)
- Issue
    - [addSpentTimeForIssue](https://docs.gitlab.com/ee/api/issues.html#add-spent-time-for-an-issue)
    - [cloneIssue](https://docs.gitlab.com/ee/api/issues.html#clone-an-issue)
    - [createIssue](https://docs.gitlab.com/ee/api/issues.html#new-issue)
    - [createTodoItem](https://docs.gitlab.com/ee/api/issues.html#create-a-to-do-item)
    - [deleteIssue](https://docs.gitlab.com/ee/api/issues.html#delete-an-issue)
    - [editIssue](https://docs.gitlab.com/ee/api/issues.html#new-issue)
    - [getGroupIssues](https://docs.gitlab.com/ee/api/issues.html#list-group-issues)
    - [getIssue](https://docs.gitlab.com/ee/api/issues.html#single-issue)
    - [getIssues](https://docs.gitlab.com/ee/api/issues.html#list-issues)
    - [getMergeRequestsRelatedToIssue](https://docs.gitlab.com/ee/api/issues.html#list-merge-requests-related-to-issue)
    - [getMergeRequestsThatClosedAnIssue](https://docs.gitlab.com/ee/api/issues.html#list-merge-requests-that-close-a-particular-issue-on-merge)
    - [getParticipants](https://docs.gitlab.com/ee/api/issues.html#participants-on-issues)
    - [getProjectIssue](https://docs.gitlab.com/ee/api/issues.html#single-project-issue)
    - [getProjectIssues](https://docs.gitlab.com/ee/api/issues.html#list-project-issues)
    - [getTimeTrackingStatsForIssue](https://docs.gitlab.com/ee/api/issues.html#get-time-tracking-stats)
    - [getUserAgentDetails](https://docs.gitlab.com/ee/api/issues.html#get-user-agent-details)
    - [moveIssue](https://docs.gitlab.com/ee/api/issues.html#move-an-issue)
    - [promoteToEpic](https://docs.gitlab.com/ee/api/issues.html#promote-an-issue-to-an-epic)
    - [reorderIssue](https://docs.gitlab.com/ee/api/issues.html#reorder-an-issue)
    - [resetSpentTimeForIssue](https://docs.gitlab.com/ee/api/issues.html#reset-spent-time-for-an-issue)
    - [resetTimeEstimateForIssue](https://docs.gitlab.com/ee/api/issues.html#reset-the-time-estimate-for-an-issue)
    - [setTimeEstimateForIssue](https://docs.gitlab.com/ee/api/issues.html#set-a-time-estimate-for-an-issue)
    - [subscribeToIssue](https://docs.gitlab.com/ee/api/issues.html#subscribe-to-an-issue)
    - [unsubscribeFromIssue](https://docs.gitlab.com/ee/api/issues.html#unsubscribe-from-an-issue)
- Link
    - Issue
       - [createLink](https://docs.gitlab.com/ee/api/issue_links.html#create-an-issue-link)
       - [deleteLink](https://docs.gitlab.com/ee/api/issue_links.html#delete-an-issue-link)
       - [getRelations](https://docs.gitlab.com/ee/api/issue_links.html#list-issue-relations)
- Repository
    - [addChangelog](https://docs.gitlab.com/ee/api/repositories.html#add-changelog-data-to-a-changelog-file)
    - [compare](https://docs.gitlab.com/ee/api/repositories.html#compare-branches-tags-or-commits)
    - [generateChangelog](https://docs.gitlab.com/ee/api/repositories.html#generate-changelog-data)
    - [getBlob](https://docs.gitlab.com/ee/api/repositories.html#get-a-blob-from-repository)
    - [getContributors](https://docs.gitlab.com/ee/api/repositories.html#contributors)
    - [getFileArchive](https://docs.gitlab.com/ee/api/repositories.html#get-file-archive)
    - [getRawBlobContent](https://docs.gitlab.com/ee/api/repositories.html#raw-blob-content)
    - [getRepositoryTree](https://docs.gitlab.com/ee/api/repositories.html#list-repository-tree)
    - [mergeBase](https://docs.gitlab.com/ee/api/repositories.html#merge-base)
    - File
        - [createFile](https://docs.gitlab.com/ee/api/commits.html#create-a-commit-with-multiple-files-and-actions)
        - [deleteFile](https://docs.gitlab.com/ee/api/commits.html#create-a-commit-with-multiple-files-and-actions)
        - [getFile](https://docs.gitlab.com/ee/api/repository_files.html#get-file-from-repository)
        - [getFileBlame](https://docs.gitlab.com/ee/api/repository_files.html#get-file-blame-from-repository)
        - [getRawFile](https://docs.gitlab.com/ee/api/repository_files.html#get-raw-file-from-repository)
        - [updateFile](https://docs.gitlab.com/ee/api/repository_files.html#create-new-file-in-repository)

# Porting to other runtimes
While the primary reason for creating Managed APIs was to use them in [ScriptRunner Connect](https://scriptrunnerconnect.com) runtime, then you can easily port them to any runtime of your choosing.

You can do so by extending the `*Core` Managed API class where you'll be asked to provide implementation for `getPlatformImplementation` function. In this implementation you have to specify how to perform buffer encoding/decoding operations and how to perform HTTP calls:
```typescript
{
    buffer: {
        encode(input: string): ArrayBuffer;
        decode(input: ArrayBuffer): string;
    },
    performHttpCall(request: Request): Promise<Response>
}
```

Here is an example how to create a [Node](https://nodejs.org/en/) port of the Managed API:
```typescript
import { GitlabApiCore } from "@managed-api/gitlab-v4-core";
import { PlatformImplementation, Request, Response, Headers } from "@managed-api/commons-core";
import fetch from "node-fetch";

export class GitlabApi extends GitlabApiCore {
    constructor(private baseUrl: string, private authToken: string) {
        super();
    }

    protected getPlatformImplementation(): PlatformImplementation {
        return {
            buffer: {
                encode: (input) => Buffer.from(input, 'utf-8'),
                decode: (input) => Buffer.from(input).toString('utf-8')
            },
            performHttpCall: (request) => this.performHttpCall(request)
        };
    }

    private async performHttpCall(request: Request): Promise<Response> {
        const requestUrl = `${this.baseUrl}${request.url}`; // Substitute base URL
        request.headers.set('Authorization', `Basic ${this.authToken}`); // Substitute auth token
        const response = await fetch(requestUrl, {
            method: request.method,
            headers: request.headers as any,
            body: request.method.toLowerCase() !== 'get' ? Buffer.from((await request.arrayBuffer()) ?? new ArrayBuffer(0)) : undefined
        });

        const apiHeaders = new Headers();
        response.headers.forEach((value, key) => apiHeaders.append(key, value));

        const body = await response.arrayBuffer();

        return super.buildResponse(response.url, response.status, response.statusText, apiHeaders, body);
    }
}
```

Please note that the authentication handling details may not be accurate and serve as an example. If you wish yo use these Managed APIs without having to concern yourself how to deal with and secure authentication details when working with APIs, then feel free to evaluate [ScriptRunner Connect](https://scriptrunnerconnect.com) platform.

# Contact
At this time Managed APIs are unlicensed and close sourced, but feel free to drop an email to [eknoll@adaptavist.com](mailto://eknoll@adaptavist.com) for ideas, suggestions and improvements.

# Changelog
* 2.2.0
    - `Breaking change:` URL and query string parameters are now URL encoded, meaning if you encoded them explicitly before you have to remove your own encoding, otherwise they will get double encoded.

* 2.1.0  
    - Url-encoded the following properties:
        - `id` in all `Repository`, `Commit`, `Epic`, `Link` and `Branch` methods.
        - `id` in the following `Issue` Methods: `getGroupIssues`, `getProjectIssues`, `getProjectIssue`, `createIssue`, `editIssue`, `deleteIssue`, `reorderIssue`, `moveIssue`, `cloneIssue`, `subscribeToIssue`, `unsubscribeFromIssue`, `createTodoItem`, `promoteToEpic`, `setTimeEstimateForIssue`, `resetTimeEstimateForIssue`, `addSpentTimeForIssue`, `resetSpentTimeForIssue`, `getTimeTrackingStatsForIssue`, `getMergeRequestsRelatedToIssue`, `getMergeRequestsThatClosedAnIssue`, `getParticipants`, `getUserAgentDetails`.
        - `branch` in `Branch.getBranch` and `Branch.deleteBranch`.
        - `file_path` in all `Repository.File` methods.

Copyright Adaptavist 2022 (c) All rights reserved
