export async function errorMessageBuilder(response, reason) {
    try {
        const error = await response.json();
        const errorMessage = (error === null || error === void 0 ? void 0 : error.message) || (error === null || error === void 0 ? void 0 : error.error);
        const errorCode = error === null || error === void 0 ? void 0 : error.error_code;
        if (errorMessage && !errorCode) {
            return `${reason} - ${errorMessage}`;
        }
        else if (errorMessage && errorCode) {
            return `${reason} - ${errorMessage}, error code: ${errorCode}`;
        }
    }
    catch { }
    return reason;
}
