export interface Commit {
    id?: string;
    short_id?: string;
    created_at?: string;
    parent_ids: string[] | null;
    title?: string;
    message?: string;
    author_name?: string;
    author_email?: string;
    authored_date?: string;
    committer_name?: string;
    committer_email?: string;
    committed_date?: string;
    trailers?: Record<string, any> | null;
    web_url?: string;
}
export interface CommitExtended extends Commit {
    stats?: {
        additions?: number;
        deletions?: number;
        total?: number;
    };
    status?: string | null;
    project_id?: number;
    last_pipeline?: null | {
        id?: number;
        ref?: string;
        sha?: string;
        status?: string;
    };
}
export interface CommitReference {
    type?: string;
    name?: string;
}
export interface PGPSignature {
    signature_type?: string;
    verification_status?: string;
    gpg_key_id?: number;
    gpg_key_primary_keyid?: string;
    gpg_key_user_name?: string;
    gpg_key_user_email?: string;
    gpg_key_subkey_id?: null | any;
    commit_source?: string;
}
export interface X509Signature {
    signature_type?: string;
    verification_status?: string;
    x509_certificate?: {
        id?: number;
        subject?: string;
        subject_key_identifier?: string;
        email?: string;
        serial_number?: number;
        certificate_status?: string;
        x509_issuer?: {
            id?: number;
            subject?: string;
            subject_key_identifier?: string;
            crl_url?: string;
        };
    };
    commit_source?: string;
}
//# sourceMappingURL=commit.d.ts.map