import { Issue } from './issue';
import { References } from './references';
import { User } from './user';
export interface Epic {
    id?: number;
    iid?: number;
    group_id?: number;
    parent_id?: number | null;
    parent_iid?: number | null;
    title?: string;
    description?: string;
    state?: string;
    confidential?: string;
    web_url?: string;
    reference?: string;
    references?: References;
    author?: User;
    start_date?: null | any;
    start_date_is_fixed?: boolean;
    start_date_fixed?: null | any;
    start_date_from_milestones?: null | any;
    start_date_from_inherited_source?: null | any;
    end_date?: string;
    due_date?: string;
    due_date_is_fixed?: boolean;
    due_date_fixed?: null | any;
    due_date_from_milestones?: string;
    due_date_from_inherited_source?: string;
    created_at?: string;
    updated_at?: string;
    closed_at?: null | string;
    labels?: any[];
    upvotes?: number;
    downvotes?: number;
    color?: string;
    _links?: {
        self?: string;
        epic_issues?: string;
        group?: string;
        parent?: string;
    };
}
export interface TodoItem {
    id?: number;
    group?: {
        id?: number;
        name?: string;
        path?: string;
        kind?: string;
        full_path?: string;
        parent_id?: null | number;
    };
    project?: {
        id?: number;
        name?: string;
        name_with_namespace?: string;
        path?: string;
        path_with_namespace?: string;
    };
    author?: User;
    action_name?: string;
    target_type?: string;
    target?: Epic | Issue;
    target_url?: string;
    body?: string;
    state?: string;
    created_at?: string;
}
//# sourceMappingURL=epic.d.ts.map