import { Epic } from './epic';
import { Milestone } from './milestone';
import { References } from './references';
import { TaskCompletionStatus } from './task_completion_status';
import { Timestats } from './time_stats';
import { User } from './user';
export interface Issue {
    state?: string;
    description?: string;
    author?: User;
    milestone?: Milestone | null;
    project_id?: number;
    assignees?: User[];
    assignee?: null | User;
    type?: string;
    updated_at?: string;
    closed_at?: null | string;
    closed_by?: null | User;
    id?: number;
    title?: string;
    created_at?: string;
    moved_to_id?: null | number;
    iid?: number;
    labels?: string[];
    upvotes?: number;
    downvotes?: number;
    merge_requests_count?: number;
    user_notes_count?: number;
    due_date?: null | string;
    web_url?: string;
    references?: References;
    time_stats?: Timestats;
    has_tasks?: boolean;
    task_status?: string;
    confidential?: boolean;
    discussion_locked?: null | boolean;
    issue_type?: string;
    severity?: string;
    _links?: {
        self?: string;
        notes?: string;
        award_emoji?: string;
        project?: string;
    };
    task_completion_status?: TaskCompletionStatus;
    weight?: null | any;
    epic_iid?: number;
    epic?: Epic;
    iteration?: {
        id?: number;
        iid?: number;
        sequence?: number;
        group_id?: number;
        title?: null | any;
        description?: null | string;
        state?: number;
        created_at?: string;
        updated_at?: string;
        start_date?: string;
        due_date?: string;
        web_url?: string;
    };
    health_status?: string;
    blocking_issues_count?: number;
    subscribed?: boolean;
    service_desk_reply_to?: null | any;
    link_type?: string;
    issue_link_id?: number;
}
export interface PromoteToEpic {
    id?: number;
    type?: null | any;
    body?: string;
    attachment?: null | any;
    author?: User;
    created_at?: string;
    updated_at?: string;
    system?: boolean;
    noteable_id?: number;
    noteable_type?: string;
    resolvable?: boolean;
    confidential?: boolean;
    noteable_iid?: number;
    commands_changes?: {
        promote_to_epic?: boolean;
    };
}
export interface UserAgent {
    user_agent?: string;
    ip_address?: string;
    akismet_submitted?: boolean;
}
//# sourceMappingURL=issue.d.ts.map