import { Milestone } from './milestone';
import { References } from './references';
import { TaskCompletionStatus } from './task_completion_status';
import { Timestats } from './time_stats';
import { User } from './user';
export interface MergeRequest {
    id?: number;
    iid?: number;
    project_id?: number;
    title?: string;
    description?: string;
    state?: string;
    created_at?: string;
    updated_at?: string;
    merged_by?: User | null;
    merge_user?: User | null;
    merged_at?: string | null;
    closed_by?: null | string;
    closed_at?: null | string;
    target_branch?: string;
    source_branch?: string;
    user_notes_count?: number;
    upvotes?: number;
    downvotes?: number;
    author?: User;
    assignees?: User[];
    assignee?: null | User;
    reviewers?: User[];
    source_project_id?: number;
    target_project_id?: number;
    labels?: string[];
    draft?: boolean;
    work_in_progress?: boolean;
    milestone?: null | Milestone;
    merge_when_pipeline_succeeds?: boolean;
    merge_status?: string;
    sha?: string;
    merge_commit_sha?: string | null;
    squash_commit_sha?: string | null;
    discussion_locked?: null | any;
    should_remove_source_branch?: null | any;
    force_remove_source_branch?: boolean;
    reference?: string;
    references?: References;
    web_url?: string;
    time_stats?: Timestats;
    squash?: boolean;
    task_completion_status?: TaskCompletionStatus;
    has_conflicts?: boolean;
    blocking_discussions_resolved?: boolean;
    approvals_before_merge?: null | any;
    changes_count?: null | any;
    latest_build_started_at?: null | any;
    latest_build_finished_at?: null | any;
    first_deployed_to_production_at?: null | any;
    pipeline?: null | any;
    head_pipeline?: null | any;
    diff_refs?: {
        base_sha?: string;
        head_sha?: string;
        start_sha?: string;
    };
    merge_error?: null | any;
    user?: {
        can_merge?: boolean;
    };
}
//# sourceMappingURL=merge_request.d.ts.map